sampleNum = 1000;
Dim = 32;
BaseSize = 8;
signal = rand(BaseSize,sampleNum);
BETAs = rand(sampleNum,Dim);
 
Dict = Normalized(rand(BaseSize,Dim));
for ii = 1 : sampleNum
    Dict = Normalized(Dict+0*rand(BaseSize,Dim));
    signal(:,ii) = Dict *BETAs(ii,:)'+ 0.002*LaplaceNoise(signal(:,ii));
end

D0 = rand(BaseSize,Dim);
D0 = Normalized(D0);
 



DL2 = BatchL2(signal,D0,BETAs);
DReW = BatchReweight(D0,signal,BETAs );

E1 = Energy(signal,DL2,BETAs);
E2 = Energy(signal,DReW,BETAs);
 


[B,C]  = MinInitOnlineRDL(D0 );
h = 2;
D = D0;
 for ii = 1 : h : sampleNum
  [D,B,C] = MinOnlineRDL2(D,signal(:,ii:min(ii+h-1,sampleNum)),BETAs(ii:min(ii+h-1,sampleNum),:),B,C,double(ii < 100) );
 end
E3 = Energy(signal,D,BETAs);

[E1,E2,E3]

Diff = sqrt(sum((D(:)- DReW(:)).^2))/sqrt(sum(D(:).^2));